"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _async = require("rxjs/scheduler/async");

var _extractData = require("../utils/extractData");

var _extractData2 = _interopRequireDefault(_extractData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var multiclick = function multiclick(stream$) {
  var scheduler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _async.async;
  var delay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 350;
  return stream$.bufferWhen(function () {
    return stream$.delay(delay, scheduler);
  }).filter(function (list) {
    return list.length >= 3;
  }).map(function (list) {
    return {
      event: "multiclick",
      meta: {
        x: list[0].clientX,
        y: list[0].clientY
      },
      data: (0, _extractData2.default)(list[0].target)
    };
  });
};

exports.default = multiclick;