"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _async = require("rxjs/scheduler/async");

var _compareQuartals = require("../utils/compareQuartals");

var _compareQuartals2 = _interopRequireDefault(_compareQuartals);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shakemove = function shakemove(stream$) {
  var scheduler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _async.async;
  var delay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 250;
  return stream$.map(function (ev) {
    return { x: ev.clientX, y: ev.clientY };
  }).bufferCount(3, 1).filter(function (list) {
    return list.length === 3 && (0, _compareQuartals2.default)(list);
  }).map(function (list) {
    return { x: list[1].x, y: list[1].y };
  }) // take the middle point
  .bufferTime(delay, scheduler).filter(function (list) {
    return list.length >= 5;
  }).map(function (list) {
    return {
      event: "shakemove",
      meta: list
    };
  });
};

exports.default = shakemove;