"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _async = require("rxjs/scheduler/async");

var wheel = function wheel(stream$) {
  var scheduler = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _async.async;
  var delay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 50;
  return stream$.debounceTime(delay, scheduler).map(function (ev) {
    return {
      event: "wheel",
      meta: {
        x: ev.clientX,
        y: ev.clientY,
        wheelDelta: ev.wheelDelta
      }
    };
  });
};

exports.default = wheel;